const getExercises = async() => {
    try {
        const res = await fetch('https://canalonce.mx/REST/data/mdb/saludable.json');
        const val = await res.json();
        return val;
    }
    catch (error) {
        console.log(error)
    }
}
/**
 * @description Funcion que obtiene un elemento html
 */   
const getElement = (element) => {
    return document.querySelector(element);
}  
/**
 * @description Función agrega una clase varios elementos html
 */   
const getAllElement = (element) => {
    return document.querySelectorAll(element);
}
const getValues = (element) => {
    return  document.querySelector('.'+element).value;
}
/**
 * @description Función agrega una clase a un elemento html
 */ 
const addClassElement = (element, typeClass) => {
    element.classList.add(typeClass);
}
/**
 * @description Función remueve una clase de un elemento html
 */ 
const removeClass = (element, typeClass) => {
    element.classList.remove(typeClass);
}
/**
 * @description Función que remueve una clase de varios elementos html
 */ 
const removeAllClass = (elements, typeClass) => {
    elements.forEach(div => {
        div.classList.remove(typeClass);
    });
}
const alertDisclaimer = () => {
    // localStorage.setItem("Disclaimer", JSON.stringify(null));

  if(JSON.parse(localStorage?.getItem("Disclaimer_s")) == null){ 
    let body = document.querySelector('html');
        body.classList.add('body-overflow');  
    let labelTitle = document.createElement("h2");
        labelTitle.classList.add('color-day-exercises', 'font-size-2', 'font-bold')
        labelTitle.innerHTML = 'Disclaimer';
    let title = 'Titulo'; 
    let description = 'Lorem ipsum dolor sit amet consectetur adipisicing elit. Velit eligendi temporibus molestias ex veniam necessitatibus sequi nisi maiores earum nemo ducimus, magnam amet ipsum minima. Distinctio, cupiditate! Quia, laboriosam. Commodi!'
    // 
    let itemModal = '<div class="description-exercices">'+
                      '<p> '+description+' </p>'+
                    '</div>';      
    let content = document.createElement("div");
        content.classList.add('info-modal-exercises')
        content.innerHTML = itemModal;     
    alertify.confirm()
            .setting({
                      'label': 'Cerrar',
                      'closable': false,
                      'title': labelTitle,
                      'message': content,
                      'invokeOnCloseOff': false,
                      'autoReset': true,
                      'pinnable': false, 
                      'modal': true,
                      'closableByDimmer': true,
                      'transitionOff': true,
                      'maintainFocus': false,
                      'overflow': false,
                      'labels': {ok:' ¡De acuerdo!', cancel:'salir'},
                      'onok': function( ){
                        body.classList.remove('body-overflow')
                        content.remove();
                        localStorage.setItem("Disclaimer", JSON.stringify(1));
                      },
                      'oncancel': function(){
                        window.location.href = "https://canalonce.mx/";
                        localStorage.setItem("Disclaimer", JSON.stringify(null));                        
                      },
                      'onclose': function(){
                        console.log('close');
                      }
                    }).show();                      
  }
}
const setItemsList = async () => {
    const contentList = getElement('.containerlist-exercises');
    let html = '';
    const data = await getExercises();
          data.forEach(ele => {
                html += '<div class="content-box d-flex item-list" '+
                              'data-id="exercises-'+ele.id+'"'+
                              'data-titulo="'+ele.titulo+'"'+
                              'data-frase="'+ele.frase+'"'+
                              'data-descripcion="'+ele.descripcion+'"'+
                              'data-iframe="'+ele.iframe+'"'+
                              'data-imagen="'+ele.imagen+'">'+
                            '<div class="img-list">'+
                                '<img alt="photo" class="img-fluid" src="https://canaloncetv.s3.amazonaws.com/REST/data/activate/'+ele.imagen+'">'+
                            '</div>'+
                            '<div class="info">'+
                                '<p class="float-right text-primary">'+ele.tipo_ejericio+'</´p>'+
                                '<h4 class=""><strong>'+ele.titulo+'</strong></h4>'+
                                '<hr>'+
                                '<p class="small text-secondary">'+ele.descripcion+'</p>'+
                            '</div>'+
                        '</div>';
          });
    contentList.innerHTML = html;  
}
$("body").on("click", ".item-list", function(e){
    let body = document.querySelector('html');
        body.classList.add('body-overflow');  
    let id = $(this).attr('data-id');
    let titulo = $(this).attr('data-titulo');
    let frase = $(this).attr('data-frase');
    let descripcion = $(this).attr('data-descripcion');
    let iframe = $(this).attr('data-iframe');
    let imagen = $(this).attr('data-imagen');
    let labelTitle = document.createElement("h2");
        labelTitle.classList.add('color-day-exercises', 'font-size-2', 'font-bold')
        labelTitle.innerHTML = 'Día de Nutrición';
    let itemModal = '<div class="container-title">'+
                        '<h2>'+titulo+'</h2>'+
                    '</div>'+
                    '<div class="container-iframe">'+
                        '<video id="VideoPlayer_'+id+'" class="video-js vjs-default-skin vjs-big-play-centered vjs-16-9" '+
                                'controls data-setup="" width="640" height="264" poster="">'+
                        '</video>'+
                    '</div>'+
                    '<div class="description-exercices">'+
                        '<p> <strong>Sinopsis: </strong> '+descripcion+' </p>'+
                        '<p> <strong>Receta: </strong> '+frase+' </p>'+
                    '</div>';
    let content = document.createElement("div");
        content.classList.add('info-modal-exercises')
        content.innerHTML = itemModal;                     
    alertify.alert()
            .setting({
                    'label': 'Cerrar',
                    'closable': true,
                    'title': labelTitle,
                    'message': content,
                    'invokeOnCloseOff': false,
                    'autoReset': true,
                    'pinnable': false, 
                    'modal': true,
                    'closableByDimmer': true,
                    'transitionOff': true,
                    'maintainFocus': false,
                    'overflow': false,
                    'onok': function( ){
                        // body.classList.remove('body-overflow')
                        // content.remove();
                        // videojs('VideoPlayer_'+id).dispose()
                    },
                    'onclose': function(){
                        body.classList.remove('body-overflow')
                        content.remove();
                        videojs('VideoPlayer_'+id).dispose()
                    }
                    }).show();
    PlayEpisode(id, iframe);
}); 
/**
 * @description Funcion que reproduce el episodio
 * @param id Id del episodio
 * @param video Video en formato youtube, vimeo, m3u8 o mp4
*/ 
function PlayEpisode(id, video) {
    // 
    var options = { 
          plugins: {
            httpSourceSelector:
            {
            default: 'auto'
            },
          },  
          techOrder: [ 'chromecast', 'html5', 'youtube', 'vimeo' ],
          controls: true,
          html5:{
            hls: {
              overrideNative: !videojs.browser.IS_SAFARI,
            },
          },
          controlBar: {
            volumePanel: {
              inline: false,
              volumeControl: {
                vertical: true
              }
            },
            fullscreenToggle: false
          },    
          youtube: {
            ytControls: 2,
            playsinline: 0,
            modestbranding: 1,
            iv_load_policy: 3,
            cc_load_policy: 0,
            
            rel: 0,
          },
      };  
    let idVideo = 'VideoPlayer_'+id;
    videojs.registerPlugin('apiVideoAnalytics', VideoJsApiVideoAnalytics);
    var reproductor =  videojs(idVideo, {options});  
        reproductor.apiVideoAnalytics({
            events: [
              {
                name: 'play',
                label: 'video play',
                action: 'play',
                event_label: video,
              },
              {
                name: 'fullscreenchange',
                label: {
                  open: 'video fullscreen open',
                  exit: 'video fullscreen exit'
                },
                action: 'fullscreen change',
                event_label: video,
              },
              {
                name: 'timeupdate',
                action: 'time updated',
                event_label: video,
              }
            ]            
          });
    if (video.includes('m3u8')) {
      reproductor.httpSourceSelector();
      reproductor.chromecast();
      reproductor.landscapeFullscreen({
                                      fullscreen: {
                                                  enterOnRotate: true,
                                                  exitOnRotate: true,
                                                  alwaysInLandscapeMode: true,
                                                  iOS: false
                                      }  
                                    });
      reproductor.src({ type: 'application/x-mpegURL', src: video });        
      reproductor.controls(true);
      reproductor.playsinline(true);
      reproductor.autoplay(true); 
    }else if (video.includes('vimeo')) {
      var repVimeo =  videojs('VideoPlayer', {});  
          repVimeo.chromecast();
  
          repVimeo.apiVideoAnalytics({
                                      events: [
                                        {
                                          name: 'play',
                                          label: 'video play',
                                          action: 'play',
                                          event_label: video,
                                        },
                                        {
                                          name: 'fullscreenchange',
                                          label: {
                                            open: 'video fullscreen open',
                                            exit: 'video fullscreen exit'
                                          },
                                          action: 'fullscreen change',
                                          event_label: video,
                                        },
                                        {
                                          name: 'timeupdate',
                                          action: 'time updated',
                                          event_label: video,
                                        }
                                      ]            
                                    });
          repVimeo.reset();
          repVimeo.src({ techOrder: ["vimeo"], type: 'video/vimeo', src: video});
          repVimeo.controls(true);
          repVimeo.playsinline(true);
          repVimeo.autoplay(true);   
          repVimeo.on('ended', function() {
            // this.dispose();
          });   
    }else if (video.includes('youtu.be') || video.includes('youtube') ||  video.includes('youtu')){
      reproductor.httpSourceSelector();
      reproductor.chromecast();
      reproductor.landscapeFullscreen({
                                      fullscreen: {
                                                  enterOnRotate: true,
                                                  exitOnRotate: true,
                                                  alwaysInLandscapeMode: true,
                                                  iOS: false
                                      }  
                                    });
      reproductor.src({ type: 'video/youtube', src: video });          
      reproductor.controls(true);
      reproductor.playsinline(false);
    }else{
      reproductor.httpSourceSelector();
      reproductor.chromecast();
      reproductor.landscapeFullscreen({
                                      fullscreen: {
                                                  enterOnRotate: true,
                                                  exitOnRotate: true,
                                                  alwaysInLandscapeMode: true,
                                                  iOS: false
                                      }  
                                    });
      reproductor.src({ type: 'video/mp4', src: video });          
      reproductor.controls(true);
      reproductor.playsinline(false);
    }  
    reproductor.on('ended', function() {
      let checkVideo = document.querySelector("#status_video");      
      let checkExce = document.querySelector("#status_success");      
          checkVideo.checked = true;
          checkExce.checked = true;
      let contentEx = document.querySelector('.container-status-exercises');
          contentEx.classList.remove('d-none');
    });
}
setTimeout(function(){
  $('.preloader').fadeOut(1000);
}, 1500);
document.addEventListener("DOMContentLoaded", function(event) {          
    setItemsList();  
    alertDisclaimer();
});
  